#
# spec file for package primus
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           primus
Version:        0+git20150328.d1afbf6
Release:        4.1
Summary:        Faster OpenGL offloading for Bumblebee
License:        HPND
Group:          Hardware/Other
Url:            https://github.com/amonakov/primus
Source0:        %{name}-%{version}.tar.xz
Source1:        baselibs.conf
Patch0:         primusrun-bsc1061561.diff
BuildRequires:  Mesa-libGL-devel
BuildRequires:  gcc-c++
BuildRequires:  libX11-devel
BuildRequires:  unzip
Requires:       bumblebee
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Primus is a shared library that provides OpenGL and GLX APIs and
implements low-overhead local-only client-side OpenGL offloading via GLX
forking, similar to VirtualGL. It intercepts GLX calls and redirects GL
rendering to a secondary X display, presumably driven by a faster GPU.
On swapping buffers, rendered contents are read back using a PBO and
copied onto the drawable it was supposed to be rendered on in the first
place.

%prep
%autosetup -p1

%build
export CXXFLAGS="%{optflags}"
export PRIMUS_libGLd=%{_libdir}/primus/libGL.so.1
export PRIMUS_libGLa=%{_libdir}/primus/libGL.so.1
make %{?_smp_mflags}

%install
install -D lib/libGL.so.1 "%{buildroot}%{_libdir}/primus/libGL.so.1"
install -D primusrun "%{buildroot}%{_bindir}/primusrun"

%files
%defattr(-,root,root)
%doc LICENSE.txt README.md
%{_libdir}/primus
%{_libdir}/primus/libGL.so.1
%{_bindir}/primusrun

%changelog
* Thu Feb 29 2024 Dominique Leuenberger <dimstar@opensuse.org>
- Use %%autosetup macro. Allows to eliminate the usage of deprecated
  %%patchN.
* Fri Oct  6 2017 Mathias.Homann@opensuse.org
- Add patch to work with our nvidia laout bsc#1061561:
  * primusrun-bsc1061561.diff
* Wed Oct  4 2017 tchvatal@suse.com
- Try to set the path to gl libraries as needed wrt bsc#995570
* Fri Aug 26 2016 tchvatal@suse.com
- Update to version 0+git20150328.d1afbf6 bsc#1051277:
  * Fix compilation on arm
  * pass any preprocessor flags defined by environment to gcc
  * Reuse initial ddpy if XOpenDisplay fails in display thread
  * Avoid using primus.ddpy in match_fbconfig
  * Avoid using primus.ddpy in match_visual (GH-132)
  * Remove some of the remaining uses of primus.ddpy
  * Defer glXChooseFBConfig from library constructor to first use (GH-151)
  * Revert back to using compiler support for ifuncs (GH-153)
  * Do not try to reuse ddpy fbconfig (fixes GH-160)
  * Fix connect() error detection (GH-163)
- Drop merged patch type-directive.patch
* Fri Jul 11 2014 schwab@linux-m68k.org
- type-directive.patch: Use %% in .type directive since @ is a comment
  character on arm
* Tue Jul  1 2014 tchvatal@suse.com
- Install the license and readme files properly.
- Respect optflags.
* Wed Jun 25 2014 tchvatal@suse.com
- Add baselibs.conf to filelist.
* Wed Jun 25 2014 cfarrell@suse.com
- license update: HPND
  See LICENSE.txt
- Install the license file.
* Tue Jan 14 2014 tchvatal@suse.com
- Needs fixing of the tarball fetching and update of license.
* Tue Jan 14 2014 tchvatal@suse.com
- Cleanup the package up to the openSUSE requirements.
* Thu Nov 29 2012 arnaldo.coelho@gmail.com
- first package version
